Index: palm/trunk/SOURCE/advec_ws.f90
===================================================================
--- palm/trunk/SOURCE/advec_ws.f90	(revision 4465)
+++ palm/trunk/SOURCE/advec_ws.f90	(revision 4466)
@@ -3389,35 +3389,35 @@
 
           u_comp(k) = u(k+1,j,i+1) + u(k,j,i+1) - gu
-          flux_r(k) = u_comp(k) * (                                           &
-                      37.0_wp * ( w(k,j,i+1) + w(k,j,i)   )                   &
-                    -  8.0_wp * ( w(k,j,i+2) + w(k,j,i-1) )                   &
+          flux_r(k) = u_comp(k) * (                                            &
+                      37.0_wp * ( w(k,j,i+1) + w(k,j,i)   )                    &
+                    -  8.0_wp * ( w(k,j,i+2) + w(k,j,i-1) )                    &
                     +           ( w(k,j,i+3) + w(k,j,i-2) ) ) * adv_mom_5
 
-          diss_r(k) = - ABS( u_comp(k) ) * (                                  &
-                      10.0_wp * ( w(k,j,i+1) - w(k,j,i)   )                   &
-                    -  5.0_wp * ( w(k,j,i+2) - w(k,j,i-1) )                   &
+          diss_r(k) = - ABS( u_comp(k) ) * (                                   &
+                      10.0_wp * ( w(k,j,i+1) - w(k,j,i)   )                    &
+                    -  5.0_wp * ( w(k,j,i+2) - w(k,j,i-1) )                    &
                     +           ( w(k,j,i+3) - w(k,j,i-2) ) ) * adv_mom_5
 
           v_comp(k) = v(k+1,j+1,i) + v(k,j+1,i) - gv
-          flux_n(k) = v_comp(k) * (                                           &
-                      37.0_wp * ( w(k,j+1,i) + w(k,j,i)   )                   &
-                    -  8.0_wp * ( w(k,j+2,i) + w(k,j-1,i) )                   &
+          flux_n(k) = v_comp(k) * (                                            &
+                      37.0_wp * ( w(k,j+1,i) + w(k,j,i)   )                    &
+                    -  8.0_wp * ( w(k,j+2,i) + w(k,j-1,i) )                    &
                     +           ( w(k,j+3,i) + w(k,j-2,i) ) ) * adv_mom_5
 
-          diss_n(k) = - ABS( v_comp(k) ) * (                                  &
-                      10.0_wp * ( w(k,j+1,i) - w(k,j,i)   )                   &
-                    -  5.0_wp * ( w(k,j+2,i) - w(k,j-1,i) )                   &
+          diss_n(k) = - ABS( v_comp(k) ) * (                                   &
+                      10.0_wp * ( w(k,j+1,i) - w(k,j,i)   )                    &
+                    -  5.0_wp * ( w(k,j+2,i) - w(k,j-1,i) )                    &
                     +           ( w(k,j+3,i) - w(k,j-2,i) ) ) * adv_mom_5
        ENDDO
 
 !
-!--    Now, compute vertical fluxes. Split loop into a part treating the 
+!--    Now, compute vertical fluxes. Split loop into a part treating the
 !--    lowest grid points with indirect indexing, a main loop without
 !--    indirect indexing, and a loop for the uppermost grip points with
 !--    indirect indexing. This allows better vectorization for the main loop.
-!--    First, compute the flux at model surface, which need has to be 
+!--    First, compute the flux at model surface, which need has to be
 !--    calculated explicitly for the tendency at
 !--    the first w-level. For topography wall this is done implicitely by
-!--    advc_flags_m.
+!--    advc_flags_m. First, compute flux at lowest level, located at z=dz/2.
        k         = nzb + 1
        w_comp(k) = w(k,j,i) + w(k-1,j,i)
@@ -3426,5 +3426,5 @@
        diss_t(0) = -ABS(w_comp(k)) * rho_air(k)                                &
                  * ( w(k,j,i) - w(k-1,j,i) ) * adv_mom_1
-       
+
        DO  k = nzb+1, nzb+1
 !
@@ -3440,37 +3440,37 @@
 
           w_comp(k) = w(k+1,j,i) + w(k,j,i)
-          flux_t(k) = w_comp(k) * rho_air(k+1) * (                            &
-                     ( 37.0_wp * ibit26 * adv_mom_5                           &
-                  +     7.0_wp * ibit25 * adv_mom_3                           &
-                  +              ibit24 * adv_mom_1                           &
-                     ) *                                                      &
-                                ( w(k+1,j,i)   + w(k,j,i)    )                &
-              -      (  8.0_wp * ibit26 * adv_mom_5                           &
-                  +              ibit25 * adv_mom_3                           &
-                     ) *                                                      &
-                                ( w(k_pp,j,i)  + w(k-1,j,i)  )                &
-              +      (           ibit26 * adv_mom_5                           &
-                     ) *                                                      &
-                                ( w(k_ppp,j,i) + w(k_mm,j,i) )                &
+          flux_t(k) = w_comp(k) * rho_air(k+1) * (                             &
+                     ( 37.0_wp * ibit26 * adv_mom_5                            &
+                  +     7.0_wp * ibit25 * adv_mom_3                            &
+                  +              ibit24 * adv_mom_1                            &
+                     ) *                                                       &
+                                ( w(k+1,j,i)   + w(k,j,i)    )                 &
+              -      (  8.0_wp * ibit26 * adv_mom_5                            &
+                  +              ibit25 * adv_mom_3                            &
+                     ) *                                                       &
+                                ( w(k_pp,j,i)  + w(k-1,j,i)  )                 &
+              +      (           ibit26 * adv_mom_5                            &
+                     ) *                                                       &
+                                ( w(k_ppp,j,i) + w(k_mm,j,i) )                 &
                                                  )
 
-          diss_t(k) = - ABS( w_comp(k) ) * rho_air(k+1) * (                   &
-                     ( 10.0_wp * ibit26 * adv_mom_5                           &
-                  +     3.0_wp * ibit25 * adv_mom_3                           &
-                  +              ibit24 * adv_mom_1                           &
-                     ) *                                                      &
-                                ( w(k+1,j,i)   - w(k,j,i)    )                &
-              -      (  5.0_wp * ibit26 * adv_mom_5                           &
-                  +              ibit25 * adv_mom_3                           &
-                     ) *                                                      &
-                                ( w(k_pp,j,i)  - w(k-1,j,i)  )                &
-              +      (           ibit26 * adv_mom_5                           &
-                     ) *                                                      &
-                                ( w(k_ppp,j,i) - w(k_mm,j,i) )                &
+          diss_t(k) = - ABS( w_comp(k) ) * rho_air(k+1) * (                    &
+                     ( 10.0_wp * ibit26 * adv_mom_5                            &
+                  +     3.0_wp * ibit25 * adv_mom_3                            &
+                  +              ibit24 * adv_mom_1                            &
+                     ) *                                                       &
+                                ( w(k+1,j,i)   - w(k,j,i)    )                 &
+              -      (  5.0_wp * ibit26 * adv_mom_5                            &
+                  +              ibit25 * adv_mom_3                            &
+                     ) *                                                       &
+                                ( w(k_pp,j,i)  - w(k-1,j,i)  )                 &
+              +      (           ibit26 * adv_mom_5                            &
+                     ) *                                                       &
+                                ( w(k_ppp,j,i) - w(k_mm,j,i) )                 &
                                                           )
        ENDDO
-       
+
        DO  k = nzb+2, nzt-2
-       
+
           ibit26 = REAL( IBITS(advc_flags_m(k,j,i),26,1), KIND = wp )
           ibit25 = REAL( IBITS(advc_flags_m(k,j,i),25,1), KIND = wp )
@@ -3478,35 +3478,35 @@
 
           w_comp(k) = w(k+1,j,i) + w(k,j,i)
-          flux_t(k) = w_comp(k) * rho_air(k+1) * (                            &
-                     ( 37.0_wp * ibit26 * adv_mom_5                           &
-                  +     7.0_wp * ibit25 * adv_mom_3                           &
-                  +              ibit24 * adv_mom_1                           &
-                     ) *                                                      &
-                                ( w(k+1,j,i)  + w(k,j,i)   )                  &
-              -      (  8.0_wp * ibit26 * adv_mom_5                           &
-                  +              ibit25 * adv_mom_3                           &
-                     ) *                                                      &
-                                ( w(k+2,j,i)  + w(k-1,j,i) )                  &
-              +      (           ibit26 * adv_mom_5                           &
-                     ) *                                                      &
-                                ( w(k+3,j,i)  + w(k-2,j,i) )                  &
+          flux_t(k) = w_comp(k) * rho_air(k+1) * (                             &
+                     ( 37.0_wp * ibit26 * adv_mom_5                            &
+                  +     7.0_wp * ibit25 * adv_mom_3                            &
+                  +              ibit24 * adv_mom_1                            &
+                     ) *                                                       &
+                                ( w(k+1,j,i)  + w(k,j,i)   )                   &
+              -      (  8.0_wp * ibit26 * adv_mom_5                            &
+                  +              ibit25 * adv_mom_3                            &
+                     ) *                                                       &
+                                ( w(k+2,j,i)  + w(k-1,j,i) )                   &
+              +      (           ibit26 * adv_mom_5                            &
+                     ) *                                                       &
+                                ( w(k+3,j,i)  + w(k-2,j,i) )                   &
                                                  )
 
-          diss_t(k) = - ABS( w_comp(k) ) * rho_air(k+1) * (                   &
-                     ( 10.0_wp * ibit26 * adv_mom_5                           &
-                  +     3.0_wp * ibit25 * adv_mom_3                           &
-                  +              ibit24 * adv_mom_1                           &
-                     ) *                                                      &
-                                ( w(k+1,j,i) - w(k,j,i)    )                  &
-              -      (  5.0_wp * ibit26 * adv_mom_5                           &
-                  +              ibit25 * adv_mom_3                           &
-                     ) *                                                      &
-                                ( w(k+2,j,i) - w(k-1,j,i)  )                  &
-              +      (           ibit26 * adv_mom_5                           &
-                     ) *                                                      &
-                                ( w(k+3,j,i) - w(k-2,j,i)  )                  &
+          diss_t(k) = - ABS( w_comp(k) ) * rho_air(k+1) * (                    &
+                     ( 10.0_wp * ibit26 * adv_mom_5                            &
+                  +     3.0_wp * ibit25 * adv_mom_3                            &
+                  +              ibit24 * adv_mom_1                            &
+                     ) *                                                       &
+                                ( w(k+1,j,i) - w(k,j,i)    )                   &
+              -      (  5.0_wp * ibit26 * adv_mom_5                            &
+                  +              ibit25 * adv_mom_3                            &
+                     ) *                                                       &
+                                ( w(k+2,j,i) - w(k-1,j,i)  )                   &
+              +      (           ibit26 * adv_mom_5                            &
+                     ) *                                                       &
+                                ( w(k+3,j,i) - w(k-2,j,i)  )                   &
                                                           )
        ENDDO
-       
+
        DO  k = nzt-1, nzt-1
 !
@@ -3522,37 +3522,37 @@
 
           w_comp(k) = w(k+1,j,i) + w(k,j,i)
-          flux_t(k) = w_comp(k) * rho_air(k+1) * (                            &
-                     ( 37.0_wp * ibit26 * adv_mom_5                           &
-                  +     7.0_wp * ibit25 * adv_mom_3                           &
-                  +              ibit24 * adv_mom_1                           &
-                     ) *                                                      &
-                                ( w(k+1,j,i)   + w(k,j,i)    )                &
-              -      (  8.0_wp * ibit26 * adv_mom_5                           &
-                  +              ibit25 * adv_mom_3                           &
-                     ) *                                                      &
-                                ( w(k_pp,j,i)  + w(k-1,j,i)  )                &
-              +      (           ibit26 * adv_mom_5                           &
-                     ) *                                                      &
-                                ( w(k_ppp,j,i) + w(k_mm,j,i) )                &
+          flux_t(k) = w_comp(k) * rho_air(k+1) * (                             &
+                     ( 37.0_wp * ibit26 * adv_mom_5                            &
+                  +     7.0_wp * ibit25 * adv_mom_3                            &
+                  +              ibit24 * adv_mom_1                            &
+                     ) *                                                       &
+                                ( w(k+1,j,i)   + w(k,j,i)    )                 &
+              -      (  8.0_wp * ibit26 * adv_mom_5                            &
+                  +              ibit25 * adv_mom_3                            &
+                     ) *                                                       &
+                                ( w(k_pp,j,i)  + w(k-1,j,i)  )                 &
+              +      (           ibit26 * adv_mom_5                            &
+                     ) *                                                       &
+                                ( w(k_ppp,j,i) + w(k_mm,j,i) )                 &
                                                  )
 
-          diss_t(k) = - ABS( w_comp(k) ) * rho_air(k+1) * (                   &
-                     ( 10.0_wp * ibit26 * adv_mom_5                           &
-                  +     3.0_wp * ibit25 * adv_mom_3                           &
-                  +              ibit24 * adv_mom_1                           &
-                     ) *                                                      &
-                                ( w(k+1,j,i)   - w(k,j,i)    )                &
-              -      (  5.0_wp * ibit26 * adv_mom_5                           &
-                  +              ibit25 * adv_mom_3                           &
-                     ) *                                                      &
-                                ( w(k_pp,j,i)  - w(k-1,j,i)  )                &
-              +      (           ibit26 * adv_mom_5                           &
-                     ) *                                                      &
-                                ( w(k_ppp,j,i) - w(k_mm,j,i) )                &
+          diss_t(k) = - ABS( w_comp(k) ) * rho_air(k+1) * (                    &
+                     ( 10.0_wp * ibit26 * adv_mom_5                            &
+                  +     3.0_wp * ibit25 * adv_mom_3                            &
+                  +              ibit24 * adv_mom_1                            &
+                     ) *                                                       &
+                                ( w(k+1,j,i)   - w(k,j,i)    )                 &
+              -      (  5.0_wp * ibit26 * adv_mom_5                            &
+                  +              ibit25 * adv_mom_3                            &
+                     ) *                                                       &
+                                ( w(k_pp,j,i)  - w(k-1,j,i)  )                 &
+              +      (           ibit26 * adv_mom_5                            &
+                     ) *                                                       &
+                                ( w(k_ppp,j,i) - w(k_mm,j,i) )                 &
                                                           )
        ENDDO
-       
-!
-!--    Set resolved/turbulent flux at model top to zero (w-level). Hint: The 
+
+!
+!--    Set resolved/turbulent flux at model top to zero (w-level). Hint: The
 !--    flux at nzt is defined at the scalar grid point nzt+1. Therefore, the
 !--    flux at nzt+1 is already outside of the model domain
@@ -3560,22 +3560,22 @@
        diss_t(nzt) = 0.0_wp
        w_comp(nzt) = 0.0_wp
-       
+
        flux_t(nzt+1) = 0.0_wp
        diss_t(nzt+1) = 0.0_wp
        w_comp(nzt+1) = 0.0_wp
-       
+
        DO  k = nzb+1, nzb_max_l
 
           flux_d    = flux_t(k-1)
           diss_d    = diss_t(k-1)
-          
+
           ibit20 = REAL( IBITS(advc_flags_m(k,j,i),20,1), KIND = wp )
           ibit19 = REAL( IBITS(advc_flags_m(k,j,i),19,1), KIND = wp )
           ibit18 = REAL( IBITS(advc_flags_m(k,j,i),18,1), KIND = wp )
-          
+
           ibit23 = REAL( IBITS(advc_flags_m(k,j,i),23,1), KIND = wp )
           ibit22 = REAL( IBITS(advc_flags_m(k,j,i),22,1), KIND = wp )
           ibit21 = REAL( IBITS(advc_flags_m(k,j,i),21,1), KIND = wp )
-          
+
           ibit26 = REAL( IBITS(advc_flags_m(k,j,i),26,1), KIND = wp )
           ibit25 = REAL( IBITS(advc_flags_m(k,j,i),25,1), KIND = wp )
@@ -3585,70 +3585,28 @@
 !--       correction is needed to overcome numerical instabilities introduced
 !--       by a not sufficient reduction of divergences near topography.
-          div = ( ( ( u_comp(k) + gu ) * ( ibit18 + ibit19 + ibit20 )         &
-                  - ( u(k+1,j,i) + u(k,j,i)   )                               & 
-                                    * (                                       &
-                     REAL( IBITS(advc_flags_m(k,j,i-1),18,1), KIND = wp )     &
-                   + REAL( IBITS(advc_flags_m(k,j,i-1),19,1), KIND = wp )     &
-                   + REAL( IBITS(advc_flags_m(k,j,i-1),20,1), KIND = wp )     &
-                                      )                                       &
-                  ) * ddx                                                     &
-              +   ( ( v_comp(k) + gv ) * ( ibit21 + ibit22 + ibit23 )         & 
-                  - ( v(k+1,j,i) + v(k,j,i)   )                               &
-                                    * (                                       &
-                     REAL( IBITS(advc_flags_m(k,j-1,i),21,1), KIND = wp )     &
-                   + REAL( IBITS(advc_flags_m(k,j-1,i),22,1), KIND = wp )     &
-                   + REAL( IBITS(advc_flags_m(k,j-1,i),23,1), KIND = wp )     &
-                                      )                                       &
-                  ) * ddy                                                     &
-              +   ( w_comp(k)               * rho_air(k+1)                    &
-                                            * ( ibit24 + ibit25 + ibit26 )    &
-                - ( w(k,j,i) + w(k-1,j,i) ) * rho_air(k)                      &
-                                    * (                                       &
-                     REAL( IBITS(advc_flags_m(k-1,j,i),24,1), KIND = wp )     &
-                   + REAL( IBITS(advc_flags_m(k-1,j,i),25,1), KIND = wp )     &
-                   + REAL( IBITS(advc_flags_m(k-1,j,i),26,1), KIND = wp )     &
-                                      )                                       & 
-                  ) * drho_air_zw(k) * ddzu(k+1)                              &
-                ) * 0.5_wp
-
-          tend(k,j,i) = tend(k,j,i) - (                                       &
-                      ( flux_r(k) + diss_r(k)                                 &
-                    -   flux_l_w(k,j,tn) - diss_l_w(k,j,tn)   ) * ddx         &
-                    + ( flux_n(k) + diss_n(k)                                 &
-                    -   flux_s_w(k,tn) - diss_s_w(k,tn)       ) * ddy         &
-                    + ( ( flux_t(k) + diss_t(k) )                             &
-                    -   ( flux_d    + diss_d    )                             &
-                                              ) * drho_air_zw(k) * ddzu(k+1)  &
-                                      ) + div * w(k,j,i)
-
-          flux_l_w(k,j,tn) = flux_r(k)
-          diss_l_w(k,j,tn) = diss_r(k)
-          flux_s_w(k,tn)   = flux_n(k)
-          diss_s_w(k,tn)   = diss_n(k)
-!
-!--       Statistical Evaluation of w'w'.
-          sums_ws2_ws_l(k,tn)  = sums_ws2_ws_l(k,tn)                          &
-                      + ( flux_t(k)                                           &
-                       * ( w_comp(k) - 2.0_wp * hom(k,1,3,0)                ) &
-                       / ( w_comp(k) + SIGN( 1.0E-20_wp, w_comp(k) )        ) &
-                        + diss_t(k)                                           &
-                       *   ABS( w_comp(k) - 2.0_wp * hom(k,1,3,0)           ) &
-                       / ( ABS( w_comp(k) ) + 1.0E-20_wp                    ) &
-                        ) *   weight_substep(intermediate_timestep_count)
-
-       ENDDO
-       
-       DO  k = nzb_max_l+1, nzt-1
-
-          flux_d    = flux_t(k-1)
-          diss_d    = diss_t(k-1)
-!
-!--       Calculate the divergence of the velocity field. A respective
-!--       correction is needed to overcome numerical instabilities introduced
-!--       by a not sufficient reduction of divergences near topography.
-          div = ( ( u_comp(k) + gu - ( u(k+1,j,i) + u(k,j,i)   ) ) * ddx       &
-              +   ( v_comp(k) + gv - ( v(k+1,j,i) + v(k,j,i)   ) ) * ddy       &
+          div = ( ( ( u_comp(k) + gu ) * ( ibit18 + ibit19 + ibit20 )          &
+                  - ( u(k+1,j,i) + u(k,j,i)   )                                &
+                                    * (                                        &
+                     REAL( IBITS(advc_flags_m(k,j,i-1),18,1), KIND = wp )      &
+                   + REAL( IBITS(advc_flags_m(k,j,i-1),19,1), KIND = wp )      &
+                   + REAL( IBITS(advc_flags_m(k,j,i-1),20,1), KIND = wp )      &
+                                      )                                        &
+                  ) * ddx                                                      &
+              +   ( ( v_comp(k) + gv ) * ( ibit21 + ibit22 + ibit23 )          &
+                  - ( v(k+1,j,i) + v(k,j,i)   )                                &
+                                    * (                                        &
+                     REAL( IBITS(advc_flags_m(k,j-1,i),21,1), KIND = wp )      &
+                   + REAL( IBITS(advc_flags_m(k,j-1,i),22,1), KIND = wp )      &
+                   + REAL( IBITS(advc_flags_m(k,j-1,i),23,1), KIND = wp )      &
+                                      )                                        &
+                  ) * ddy                                                      &
               +   ( w_comp(k)               * rho_air(k+1)                     &
-                - ( w(k,j,i) + w(k-1,j,i) ) * rho_air(k)                       & 
+                                            * ( ibit24 + ibit25 + ibit26 )     &
+                - ( w(k,j,i) + w(k-1,j,i) ) * rho_air(k)                       &
+                                    * (                                        &
+                     REAL( IBITS(advc_flags_m(k-1,j,i),24,1), KIND = wp )      &
+                   + REAL( IBITS(advc_flags_m(k-1,j,i),25,1), KIND = wp )      &
+                   + REAL( IBITS(advc_flags_m(k-1,j,i),26,1), KIND = wp )      &
+                                      )                                        &
                   ) * drho_air_zw(k) * ddzu(k+1)                               &
                 ) * 0.5_wp
@@ -3681,6 +3639,48 @@
        ENDDO
 
+       DO  k = nzb_max_l+1, nzt-1
+
+          flux_d    = flux_t(k-1)
+          diss_d    = diss_t(k-1)
+!
+!--       Calculate the divergence of the velocity field. A respective
+!--       correction is needed to overcome numerical instabilities introduced
+!--       by a not sufficient reduction of divergences near topography.
+          div = ( ( u_comp(k) + gu - ( u(k+1,j,i) + u(k,j,i)   ) ) * ddx       &
+              +   ( v_comp(k) + gv - ( v(k+1,j,i) + v(k,j,i)   ) ) * ddy       &
+              +   ( w_comp(k)               * rho_air(k+1)                     &
+                - ( w(k,j,i) + w(k-1,j,i) ) * rho_air(k)                       &
+                  ) * drho_air_zw(k) * ddzu(k+1)                               &
+                ) * 0.5_wp
+
+          tend(k,j,i) = tend(k,j,i) - (                                        &
+                      ( flux_r(k) + diss_r(k)                                  &
+                    -   flux_l_w(k,j,tn) - diss_l_w(k,j,tn)   ) * ddx          &
+                    + ( flux_n(k) + diss_n(k)                                  &
+                    -   flux_s_w(k,tn) - diss_s_w(k,tn)       ) * ddy          &
+                    + ( ( flux_t(k) + diss_t(k) )                              &
+                    -   ( flux_d    + diss_d    )                              &
+                                              ) * drho_air_zw(k) * ddzu(k+1)   &
+                                      ) + div * w(k,j,i)
+
+          flux_l_w(k,j,tn) = flux_r(k)
+          diss_l_w(k,j,tn) = diss_r(k)
+          flux_s_w(k,tn)   = flux_n(k)
+          diss_s_w(k,tn)   = diss_n(k)
+!
+!--       Statistical Evaluation of w'w'.
+          sums_ws2_ws_l(k,tn)  = sums_ws2_ws_l(k,tn)                           &
+                      + ( flux_t(k)                                            &
+                       * ( w_comp(k) - 2.0_wp * hom(k,1,3,0)                )  &
+                       / ( w_comp(k) + SIGN( 1.0E-20_wp, w_comp(k) )        )  &
+                        + diss_t(k)                                            &
+                       *   ABS( w_comp(k) - 2.0_wp * hom(k,1,3,0)           )  &
+                       / ( ABS( w_comp(k) ) + 1.0E-20_wp                    )  &
+                        ) *   weight_substep(intermediate_timestep_count)
+
+       ENDDO
+
     END SUBROUTINE advec_w_ws_ij
-    
+
 
 !------------------------------------------------------------------------------!
